﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace InteropTest
{
    [StructLayout(LayoutKind.Sequential)]
    unsafe public struct fng_curve
    {
        public fixed double tenor[5000];
    }

    [StructLayout(LayoutKind.Sequential)]
    unsafe public struct fng_curve_list
    {
        public int size;
        public fng_curve *data;
    }

    class Program
    {
        [DllImport("InteropWin32.dll")]
        public unsafe static extern void fnInterop1(fng_curve_list *data);
        [DllImport("InteropWin32.dll")]
        public unsafe static extern void fnInterop2(fng_curve_list *data);

        static void Main(string[] args)
        {
            fng_curve_list data = new fng_curve_list();
            unsafe
            {
                fng_curve_list* item = &data;
                fnInterop1(item);

                for (int i = 0; i < item->size; i++)
                {
                    fng_curve pCurve = item->data[i];
                }

                fnInterop2(item);
            }
        }
    }
}
